#Un réseau de Thomas hybride : V,M,E,C

from module_formule import *
import os.path #gére la création du fichier de sortie du simulateur
import math #permet de gérer l'infini
import sys
from module_fonction import *

##################################
############## MAIN ##############
##################################

while (t<=tmax) and (len(var)!=0): # FLAG : tant que le temps maximal de simulation n'est pas dépassé et tant que le système ne se trouve pas dans un état stable (aucune variable ne change d'état ni ne varie de coordonnées fractionnaires) :  
	res=first(h_courant[0],h_courant[1],var) #appel de la fonction first. Calcul du délai d'atteinte du bord de l'état courant (h_courant[0]) pour chaque variable du système,
	vfirst=res[0] #la variable first vfirst représente dans ce programme la variable qui ateint le bord de l'état en premier (délai d'atteinte du bord le plus petit),
	dicot_etat=res[1] #dicot_etat, un dictionnaire associant à chaque variable le délai d'atteinte du bord de l'état courant,
	tfirst=dicot_etat[vfirst] #tfirst, le délai minimum d'atteinte du bord de l'état courant par la variable vfirst,
	dico_val_cele_courant=make_dicovalcele(G,h_courant[0],M,D) #dico_val_cele_courant, un dictionnaire associant à chaque variable, la valeur de sa célérité dans l'état courant, 
	h_suivant=new_position(var,var_copie,dico_val_cele_courant,h_courant,vfirst,dicot_etat) #hsuivant, un tuple avec h_suivant[0] = le niveau discret de chaque variable et h_suivant[1] = coordonnées fractionnaires de chaque variable. Calcul des nouvelles coordonnées fractionnaires, au pas tfirst suivant, de chaque variable à l'intérieur d'un même état.
	t=tfirst+t #actualisation du temps t après écoulement de tfirst,
	if t<=tmax: #si le temps maximal de simulation n'est pas dépassé, 
		printinfile(var_copie,h_suivant,t) #alors écriture du temps actualisé et des niveaux discrets + coordonnées fractionnaires de chaque variable dans le fichier de sortie de simulation,
	if t>tmax and (tfirst>tmax): #si le temps maximal de simulation est dépassé (à l'intérieur du while) et que le tfirst est supérieur au temps de simulation maximal défini en entrée, alors : 
		pi_next={}
		etat_init=h_courant[0] #extraction de l'état courant pour le calcul suivant,
		pi_init=h_courant[1] #extraction de l'ensemble des coordonnées fractionnaires courantes de chaque variable, 
		for v in var: #pour chaque variable du graphe d'interaction, 
			cele_v=dico_val_cele_courant[v] #calcul de la valeur de sa célérité dans l'état courant considéré,
			pi_n=(pi_init[v])+(tmax*cele_v) #calcul de sa partie fractionnaire au temps max dans l'état courant considéré,
			pi_next[v]=pi_n #stockge de la valeur de la partie fractionnaire associée à la variable correspondante dans le dictionnaire pi_next,
			for vc in var_copie: #vc est une copie de la liste intacte des variables. Losqu'une variable glisse sur un mur, on la supprime de la liste des variables var afin de recalculer par la suite la variable first vfirst et son délai d'atteinte du bord tfirst. 
				if vc not in var: #si la variable vc ne se trouve pas dans var alors vc est une variabe glissante. 
					pi_next[vc]=pi_init[vc] #la partie fractionnaire de la variable glissane ne change pas au cours du temps. 
		h_suivant=(etat_init,pi_next) #construction du tuple h_suivant
		printinfile(var_copie,h_suivant,tmax) #écriture du temps actualisé et des niveaux discrets + coordonnées fractionnaires des variables glissantes dans le fichier de sortie de simulation,
	h_courant=h_suivant  #actualisation de h_courant,
	dico_val_cele_courant=make_dicovalcele(G,h_courant[0],M,D) #recalcul des célérités et de leurs valeurs de l'état actualisé,
	etat_voisin=etats_voisin(graphe_etat,h_courant[0],vfirst,dico_val_cele_courant) #extraction de l'état voisin de l'état courant h_courant [0] dans la direction et le sens d'évolution de vfirst, 
	if len(etat_voisin)!=0: #si l'état courant possède un voisin (niveau maximal ou minimal de vfirst non atteint),
		dico_val_cele_voisin=make_dicovalcele(G,etat_voisin,M,D) #calcul des célérités et de leurs valeurs de l'état voisin,
		if not slide_knocking_variable(graphe_etat,D,vfirst,h_courant[0],etat_voisin,dico_val_cele_courant,dico_val_cele_voisin): #si la variable vfirst NE GLISSE PAS le long de son bord (cas de glissement : saturation, dégradation totale, ou mur noir), 
			pi_next=h_courant[1] 
			h_suivant=new_position_new_state(dico_val_cele_courant,etat_voisin,pi_next,vfirst) # Calcul des nouvelles coordonnées fractionnaires, à un même temps t, dans l'état voisin. Franchissement du seuil de vfirst. 
			h_courant=h_suivant #actualisation de h_courant,
			if t<=tmax: #si le temps maximal de simulation n'est pas dépassé, 
				printinfile(var_copie,h_courant,t) #alors écriture du temps t et des niveaux discrets + coordonnées fractionnaires de chaque variable dans le fichier de sortie de simulation,
			var=liste_variable(G) #réinitialisation de la liste des variales var, car atteinte d'un autre état, 
		else: #sinon vfirst glisse,
			var.remove(vfirst) #suppression de la vfirst de la liste des variable car vfirst glisse,
	else: #sinon, l'état courant n'a pas de voisin (niveau maximal ou minimal de vfirst atteint),
		var.remove(vfirst) #suppression de la vfirst de la liste des variable car vfirst glisse.
f.close() #fermeture du ficier de simulation. 

if len(var)==0: #si le système se trouve dans un état stable (aucune variable ne change d'état ni ne varie de coordonnées fractionnaires) car toute la variables glissent :
	print('La dynamique du système tend vers un état stable.') #information de l'utilisateur de l'état du système, 
	etat=h_suivant[0] #extraction de l'état discret de chaque variable,
	pi=h_suivant[1] #extraction de l'ensemble des coordonnées fractionnaires de chaque vaiable,
	f = open('simulation.txt','a') #ouverture du fichier de sortie de simulation,
	f.write('\n' + str(tmax) + '\t') #écriture du temps maximal de simulation dans le fichier de sortie,
	for vc in var_copie: #pour chaque vaiable v du graphe d'interation G, 
		val=etat[vc]+pi[vc] #calcul du niveau discret de vd + coordonnée fractionnaire de vc. 
		f.write(str(val) + '\t') #écriture de val dans le ficier de sortie de simulation pour chaque variable.
	f.close() #fermeture du fichier de simulation,
if t>=tmax: #lorsque tmax est ateint ou dépassé, 
	print('############\n### Done ###\n############') #information de l'utilisateur : le programme a fini d'être éxécuté. 
